#include "StdAfx.h"
#include "UpdateNoticeController.h"
#include "NoticeDlg.h"

CUpdateNoticeController *CUpdateNoticeController::g_pUpdateNoticeController = NULL;

CUpdateNoticeController* CUpdateNoticeController::CreateNotice(LPCTSTR strNoticeUrl)
{
	if(strNoticeUrl == NULL)
		return NULL;

	if(g_pUpdateNoticeController == NULL)
	{
		g_pUpdateNoticeController = new CUpdateNoticeController;
	}

	g_pUpdateNoticeController->SetUrl(strNoticeUrl);

	return g_pUpdateNoticeController;
}

void CUpdateNoticeController::DeleteNotice()
{
	if(g_pUpdateNoticeController)
	{
		g_pUpdateNoticeController->DeleteView();
		delete g_pUpdateNoticeController;
		g_pUpdateNoticeController = NULL;
	}
}


CUpdateNoticeController::CUpdateNoticeController(void) : m_pNoticeDlg(NULL), m_strUrl(_T(""))
{
	CreateNoticeView();		
}

CUpdateNoticeController::~CUpdateNoticeController(void)
{
}

void CUpdateNoticeController::SetUrl( LPCTSTR strUrl )
{	
	m_strUrl = strUrl;	
}

void CUpdateNoticeController::ShowNotice()
{
	if(m_pNoticeDlg == NULL)
		CreateNoticeView();

	m_pNoticeDlg->Navigate(m_strUrl);	
	m_pNoticeDlg->ShowWindow(SW_SHOW);
	m_pNoticeDlg->SetForegroundWindow();

}

void CUpdateNoticeController::DeleteView()
{
	if(m_pNoticeDlg)
	{		
		m_pNoticeDlg->DestroyWindow();
		delete m_pNoticeDlg;
		m_pNoticeDlg = NULL;
	}
}

void CUpdateNoticeController::CreateNoticeView()
{
	m_pNoticeDlg = new CNoticeDlg(CWnd::GetDesktopWindow());

	if(m_pNoticeDlg == NULL)
		ASSERT(FALSE);
	else
		m_pNoticeDlg->SetIsUpdateNotice(TRUE);

	if(m_pNoticeDlg->Create(CNoticeDlg::IDD, CWnd::GetDesktopWindow()) == FALSE)
	{
		delete m_pNoticeDlg;
		m_pNoticeDlg = NULL;
		ASSERT(FALSE);
	}
}
